/*
 * ========================================================================
 * (c) Copyright 2021-2022 Micro Focus or one of its affiliates.
 * ========================================================================
 */
var getEntitiesKind = function(kind) {
  if(kind !== null) {
    switch(kind) {
      case 'group':
        return 'GROUP';
      case 'classification':
        return 'ACCOUNT_CATEGORY';
      case 'reportingUpTo':
        return 'REPORTING_UP_TO';
    }
  }
}

var getAttributeText = function(attr, subtype, entityType) {
  if(attr !== null && subtype !== null) {
        if(attr.indexOf('ext_') !== -1) {
            return attr.substring(4);
        }
        
        switch (attr) {
          case 'accountGrant':
              return 'GRANTS_ACCOUNT';
      
          case 'administrators':
              return 'ADMINS';
      
          case 'affiliatedApplication':
              return 'AFFILIATED_APP';
              
          case 'affiliatedId':
              return 'AFFILIATED_ID';
      
          case 'aliases':
              return 'ALIASES';
      
          case 'assetId':
              return 'ASSET_ID';
      
          case 'assetTag':
              return 'ASSET_TAG';
      
          case 'assignable':
              return 'ASSIGNABLE';
      
          case 'atype':
              return 'ATYPE';
      
          case 'authoritative':
              return 'AUTHORITATIVE';
      
          case 'authsUpdatedDate':
              return 'AUTH_UPDATE_DATE';
      
          case 'autoGenerated':
              return 'AUTO_GENERATED';
      
          case 'boundable':
              return 'BOUNDABLE';
      
          case 'city':
              return 'CITY';
      
          case 'classification':
              return 'CLASSIFICATION';
      
          case 'collectedUniqueAppId':
              return 'COLL_APP_UNIQUE_ID';
      
          case 'cost':
              if(subtype === 'PERMISSION'){
                  return 'PERMISSION_COST';
              }else if (subtype === 'ACCOUNT'){
                  return 'ACCOUNT_COST';
              }else{
                  return 'COST';
              }
      
          case 'costType':
              return 'COST_TYPE';
      
          case 'country':
              return 'COUNTRY';
      
          case 'createDate':
              return 'CREATE_DATE';
      
          case 'createdBy':
              return 'CREATED_BY';
      
          case 'currency':
              return 'CURRENCY';
      
          case 'deleteDate':
              return 'DELETED_DATE';
      
          case 'department':
              return 'DEPARTMENT';
      
          case 'description':
              if(subtype === 'PERMISSION'){
                  return 'PERM_DESCRIPTION';
              }else if(subtype === 'ACCOUNT'){
                  return 'ACCOUNT_DESCRIPTION';
              }else{
                  return 'DESCRIPTION';
              }
      
          case 'detectStatus':
              return 'DETECT_STATUS';
      
          case 'digestId':
              return 'DIGEST_ID';
      
          case 'disabled':
              return 'DISABLED';
      
          case 'displayDescription':
              return 'DISP_DESCRIPTION';
      
          case 'displayName':
              return 'DISPLAY_NAME';
      
          case 'dn':
              return 'LDAP_DISTINGUISHED_NAME';
      
          case 'dnsAddress':
              return 'DNS';
      
          case 'emails':
              return 'EMAILS';
      
          case 'employeeStatus':
              return 'EMPLOYEE_STATUS';
      
          case 'employeeType':
              return 'EMPLOYEE_TYPE';
      
          case 'endTime':
              return 'END_TIME';
      
          case 'entityCategories':
              return 'CATEGORIES';
      
          case 'environment':
              return 'ENVIRONMENT';
      
          case 'excludeFromCatalog':
              return 'EXCLUDE_FROM_CATALOG';
      
          case 'firstName':
              return 'FIRST_NAME';
      
          case 'fullName':
              return 'FULL_NAME';
      
          case 'geoLocation':
              return 'GEO_LOCATION';
      
          case 'gracePeriod':
              return 'GRACE_PERIOD';
      
          case 'homePhone':
              return 'HOME_PHONE';
      
          case 'idmAccountId':
              return 'IDM_ACCOUNT_ID';
      
          case 'idmDn':
              return 'IDM_DN';
      
          case 'idmTreeName':
              return 'IDM_TREE';
      
          case 'ipAddress':
              return 'IP_ADDRESS';
      
          case 'jobCode':
              return 'JOB_CODE';
      
          case 'jobTitle':
              return 'JOB_TITLE';
      
          case 'lastAccountReview':
              return 'LAST_ACCOUNT_REVIEW';
      
          case 'lastDetectTime':
              return 'LAST_DETECT_TIME';
      
          case 'lastLogin':
              return 'LAST_LOGIN_DATE';
      
          case 'lastName':
              return 'LAST_NAME';
      
          case 'licenseType':
              return 'LICENSE_TYPE';
      
          case 'location':
              if(subtype === 'APPLICATION'){
                  return 'APP_LOCATION';
              }else{
                  return 'LOCATION'
              }
      
          case 'loginCount':
              return 'LOGIN_COUNT';
      
          case 'membershipUpdatedDate':
              return 'MEMB_UPDATE_DATE';
      
          case 'middleName':
              return 'MIDDLE_NAME';
      
          case 'name':
              if(subtype === 'APPLICATION'){
                  return 'APPLICATION_NAME';
              }else if(subtype === 'ACCOUNT'){
                  return 'ACCOUNT_NAME';
              }else if(subtype === 'PERMISSION'){
                  return 'PERMISSION_NAME';
              }else{
                  return 'NAME';
              }
      
          case 'notReviewable':
              return 'NOT_REVIEWABLE';
      
          case 'officePhone':
              return 'OFFICE_PHONE';
      
          case 'originalCreateDate':
              return 'ORIGINAL_CREATE_DATE';
      
          case 'otherPhone':
              return 'OTHER_PHONE';
      
          case 'owners':
              if(subtype === 'ACCOUNT'){
                  return 'ACCOUNT_CUSTODIANS';
              }else if(subtype === 'PERMISSION'){
                  return 'PERMISSION_OWNERS';
              }else{
                  return 'OWNERS';
              }
      
          case 'privileged':
              return 'PRIVILEGED';
      
          case 'provAttribute':
              return 'PROV_ATTRIBUTE';
      
          case 'provisionable':
              return 'PROVISIONABLE';
      
          case 'provNativeValue':
              return 'PROV_NATIVE_VALUE';
      
          case 'relationToUserType':
              return 'RELATION_TO_USER';
      
          case 'risk':
              if(subtype === 'ACCOUNT'){
                  return 'ACCOUNT_RISK';
              }else if(subtype === 'APPLICATION'){
                  return 'APP_RISK';
              }else if(subtype === 'USER'){
                  return 'USER_RISK';
              }else if(subtype === 'PERMISSION'){
                  if (entityType === 'PERMISSION'){
                      return 'PERM_RISK';
                  }else if(entityType === 'PERMISSION_ASSIGNMENT'){
                      return 'ASSIGNMENT_RISK'
                  }else{
                      return 'RISK';
                  }
              }else{
                  return 'RISK';
              }
      
          case 'showAccountNameOnReviewItem':
              return 'SHOW_ACCOUNT_NAME';
      
          case 'showPermissionHierachy':
              return 'SHOW_PERMISSION_HIERARCHY';
      
          case 'startTime':
              return 'START_TIME';
      
          case 'state':
              if(subtype === 'ACCOUNT'){
                  return 'ACCOUNT_STATE';
              }else{
                  return 'STATE'
              }
      
          case 'staticPermission':
              return 'STATIC_PERMISSION_FLAG';
      
          case 'supervisor':
              return 'MANAGED_BY';
      
          case 'tags':
              return 'TAGS';
      
          case 'treeName':
              return 'IDM_TREE';
      
          case 'type':
              if(subtype === 'ACCOUNT'){
                  return 'ACCOUNT_TYPE';
              }else if (subtype === 'PERMISSION'){
                  return 'PERM_TYPE';
              }else{
                  return attr;
              }
      
          case 'uniqueApplicationId':
              return 'UNIQUE_APP_ID';
      
          case 'updatedBy':
              return 'UPDATED_BY';
      
          case 'userLink':
              return 'USER_LINK';
      
          case 'value':
              return 'VALUE';
      
          case 'valueType':
              return 'VALUE_TYPE';
      
          case 'vendor':
              return 'VENDOR';
      
          case 'vendorVersion':
              return 'VENDOR_VERSION';
      
          case 'workforceId':
              return 'WORKFORCE_ID';
          default:
              return attr;
      }
  }                            
};

var getOperatorText = function(op) {
  if (op !== null) {
      switch (op) {
          case 'GT':
              return 'GREATER_THAN';
          case 'LT':
              return 'LESS_THAN';
          case 'EQ':
              return 'EQUAL_TO';
          case 'GE':
              return 'GREATER_THAN_EQ';
          case 'LE':
              return 'LESS_THAN_EQ';
      }
  }                        
};

var getDaysAgoOperatorText = function(op) {
  if (op !== null) {
    switch (op) {
      case 'GT':
        return 'MORE_THAN';
      case 'LT':
        return 'WITHIN';
    }
  }
}

var getDaysAheadOperatorText = function(op) {
  if (op !== null) {
    switch (op) {
      case 'GT':
        return 'MORE_THAN';
      case 'LT':
        return 'WITHIN';
    }
  }
}

var getDateOperatorText = function(op) {
  if (op !== null) {
    switch (op) {
        case 'GT':
            return 'AFTER';
        case 'LT':
            return 'BEFORE';
        case 'EQ':
            return 'ON';
        case 'GE':
            return 'ON_OR_AFTER';
        case 'LE':
            return 'ON_OR_BEFORE';
    }
} 
}

var parseAccountInfo = function(jsonObj, localizer, acct_type) {
  var resultList = [];
  if(jsonObj.selectedAccts !== undefined) {
    //with selected accounts
    if(acct_type === 'ACCOUNT')
      resultList.push('SELECT_ACCOUNTS');
    else
      resultList.push('SELECT_MAPPED_ACCOUNTS');
    
    //getting the account names
    resultList.push(jsonObj.selectedAccts.map(function (selectedAccount) {
      return (selectedAccount.displayName && selectedAccount.displayName !== '\u00BF' ? selectedAccount.displayName : localizer.getString('NO_NAME'));
    }).join(' | '));

    if(jsonObj.acctCriteria !== undefined) {
      //with selected accounts with criteria

      if(jsonObj.acctConjunction === 'AllOf') {
        //AND_ACCOUNTS_MATCH_ALL=as well as accounts that match all of the following selection criteria
        if(acct_type === 'ACCOUNT') {
          resultList.push('AND_ACCOUNTS_MATCH_ALL');
        }
        else
          resultList.push('AND_MAPPED_ACCOUNTS_MATCH_ALL');
      } 
      else {
        //AND_ACCOUNTS_MATCH_ANY=as well as accounts that match any of the following selection criteria
        if(acct_type === 'ACCOUNT')
          resultList.push('AND_ACCOUNTS_MATCH_ANY');
        else
          resultList.push('AND_MAPPED_ACCOUNTS_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.acctCriteria, 'ACCOUNT'));
    } else {
      resultList.push('<br>');
    }
  } 
  else {
    if(jsonObj.acctCriteria !== undefined) {
      //without selected accounts with criteria
      if(jsonObj.acctConjunction === 'AllOf') {
        //ACCOUNTS_MATCH_ALL=select accounts that match all of the following selection criteria
        if(acct_type === 'ACCOUNT') {
          resultList.push('ACCOUNTS_MATCH_ALL');
        } else {
          resultList.push('MAPPED_ACCOUNTS_MATCH_ALL');
        }
      } 
      else {
        //ACCOUNTS_MATCH_ANY=select accounts that match any of the following selection criteria
        if(acct_type === 'ACCOUNT') {
          resultList.push('ACCOUNTS_MATCH_ANY');
        } else {
          resultList.push('MAPPED_ACCOUNTS_MATCH_ANY');
        }
      }
      
      resultList = resultList.concat(parseCriteria(jsonObj.acctCriteria, 'ACCOUNT'));
    } 
    else {
      //without selected accounts and without criteria
      if(acct_type === 'ACCOUNT') {
        resultList.push('ALL_ACCOUNTS');
      } else {
        resultList.push('ALL_MAPPED_ACCOUNTS');
      }
      resultList.push('<br>');
    }
  }
  
  return resultList;
}

var parseApplicationInfo = function(jsonObj) {
  var resultList = [];
  if(jsonObj.selectedApps !== undefined) {
    //with selected accounts
    resultList.push('SELECT_APPLICATIONS');
    
    //getting the account names
    resultList.push(jsonObj.selectedApps.map(function (selectedApp) {return selectedApp.displayName;}).join(' | '));

    if(jsonObj.appCriteria !== undefined) {
      //with selected accounts with criteria

      if(jsonObj.appConjunction === 'AllOf') {
        //AND_ACCOUNTS_MATCH_ALL=as well as accounts that match all of the following selection criteria
        resultList.push('AND_APPLICATIONS_MATCH_ALL');
      } 
      else {
        //AND_ACCOUNTS_MATCH_ANY=as well as accounts that match any of the following selection criteria
        resultList.push('AND_APPLICATIONS_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.appCriteria, 'APPLICATION'));
    } else {
      resultList.push('<br>');
    }
  } 
  else {
    if(jsonObj.appCriteria !== undefined) {
      //without selected accounts with criteria
      if(jsonObj.appConjunction === 'AllOf') {
        //ACCOUNTS_MATCH_ALL=select accounts that match all of the following selection criteria
        resultList.push('APPLICATIONS_MATCH_ALL');
      } 
      else {
        //ACCOUNTS_MATCH_ANY=select accounts that match any of the following selection criteria
        resultList.push('APPLICATIONS_MATCH_ANY');
      }
      
      resultList = resultList.concat(parseCriteria(jsonObj.appCriteria, 'APPLICATION'));
    } 
    else {
      //without selected accounts and without criteria
      resultList.push('ALL_APPLICATIONS');
      resultList.push('<br>');
    }
  }
  
  return resultList;
}

var parsePermissionInfo = function (jsonObj, localizer) {
  var resultList = [];
  if(jsonObj.selectedPerms !== undefined) {
    //with selected accounts
    resultList.push('SELECT_PERMISSIONS');
    
    //getting the account names
    resultList.push(jsonObj.selectedPerms.map(function (selectedPerm) {
      return (selectedPerm.displayName && selectedPerm.displayName !== '\u00BF' ? selectedPerm.displayName : localizer.getString('NO_NAME'));
    }).join(' | '));

    if(jsonObj.permCriteria !== undefined) {
      //with selected accounts with criteria

      if(jsonObj.permConjunction === 'AllOf') {
        //AND_ACCOUNTS_MATCH_ALL=as well as accounts that match all of the following selection criteria
        resultList.push('AND_PERMISSIONS_MATCH_ALL');
      } 
      else {
        //AND_ACCOUNTS_MATCH_ANY=as well as accounts that match any of the following selection criteria
        resultList.push('AND_PERMISSIONS_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.permCriteria, 'PERMISSION'));
    } else {
      resultList.push('<br>');
    }
  } 
  else {
    if(jsonObj.permCriteria !== undefined) {
      //without selected accounts with criteria
      if(jsonObj.permConjunction === 'AllOf') {
        //ACCOUNTS_MATCH_ALL=select accounts that match all of the following selection criteria
        resultList.push('PERMISSIONS_MATCH_ALL');
      } 
      else {
        //ACCOUNTS_MATCH_ANY=select accounts that match any of the following selection criteria
        resultList.push('PERMISSIONS_MATCH_ANY');
      }
      
      resultList = resultList.concat(parseCriteria(jsonObj.permCriteria, 'PERMISSION'));
    } 
    else {
      //without selected accounts and without criteria
      resultList.push('ALL_PERMISSIONS');
      resultList.push('<br>');
    }
  }
  
  return resultList;  
}

var parseUserInfo = function (jsonObj, localizer) {
  var resultList = [];
  if(jsonObj.selectedUsers !== undefined) {
    //with selected accounts
    resultList.push('SELECT_USERS');
    
    //getting the account names
    resultList.push(jsonObj.selectedUsers.map(function (selectedUser) {
      return selectedUser.displayName && selectedUser.displayName !== '\u00BF \u00BF' ? selectedUser.displayName : localizer.getString('NO_NAME');
    }).join(' | '));
    
    if(jsonObj.userCriteria !== undefined) {
      //with selected accounts with criteria

      if(jsonObj.userConjunction === 'AllOf') {
        //AND_ACCOUNTS_MATCH_ALL=as well as accounts that match all of the following selection criteria
        resultList.push('AND_USERS_MATCH_ALL');
      } 
      else {
        //AND_ACCOUNTS_MATCH_ANY=as well as accounts that match any of the following selection criteria
        resultList.push('AND_USERS_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.userCriteria));
    } else {
      resultList.push('<br>');
    }
  } 
  else {
    if(jsonObj.userCriteria !== undefined) {
      //without selected accounts with criteria
      if(jsonObj.userConjunction === 'AllOf') {
        //ACCOUNTS_MATCH_ALL=select accounts that match all of the following selection criteria
        resultList.push('USERS_MATCH_ALL');
      } 
      else {
        //ACCOUNTS_MATCH_ANY=select accounts that match any of the following selection criteria
        resultList.push('USERS_MATCH_ANY');
      }
      
      resultList = resultList.concat(parseCriteria(jsonObj.userCriteria));
    } 
    else {
      //without selected accounts and without criteria
      resultList.push('ALL_USERS');
      resultList.push('<br>');
    }
  }
  
  return resultList;  
}

var parseOrphanInfo = function (jsonObj) {
  var resultList = [];

  if(jsonObj.selectedOrphanAccts !== undefined) {
    //with selected orphans
    resultList.push('SELECT_ORPHANS');
    
    //getting the orphan names
    resultList.push(jsonObj.selectedOrphanAccts.map(function (selectedOrphan) {
      return(selectedOrphan.displayName && selectedOrphan.displayName !== '\u00BF' ? selectedOrphan.displayName : localizer.getString('NO_NAME'));
    }).join(' | '));
    
    if(jsonObj.orphanAcctCriteria !== undefined) {
      //with selected accounts with criteria

      if(jsonObj.orphanAcctConjunction === 'AllOf') {
        //AND_ACCOUNTS_MATCH_ALL=as well as accounts that match all of the following selection criteria
        resultList.push('AND_ORPHANS_MATCH_ALL');
      } 
      else {
        //AND_ACCOUNTS_MATCH_ANY=as well as accounts that match any of the following selection criteria
        resultList.push('AND_ORPHANS_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.orphanAcctCriteria, 'ORPHAN'));
    } else {
      resultList.push('<br>');
    }
  }
  else{
    if(jsonObj.orphanAcctCriteria !== undefined) {
      if(jsonObj.orphanAcctConjunction === 'AllOf'){

        resultList.push('ORPHANS_MATCH_ALL');
      } 
      else {

        resultList.push('ORPHANS_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.orphanAcctCriteria, 'ORPHAN'));
    }

    else {
      resultList.push('ALL_ORPHANS');
      resultList.push('<br>');
    }
  }
  return resultList;
}

var parseRoleInfo = function (jsonObj) {
  var resultList = [];

  if(jsonObj.selectedRoles !== undefined) {
    //with selected roles
    resultList.push('SELECT_ROLES');
    
    //getting the role names
    resultList.push(jsonObj.selectedRoles.map(function (selectedRole) {return selectedRole.displayName;}).join(' | '));
    
    if(jsonObj.roleCriteria !== undefined) {

      if(jsonObj.roleConjunction === 'AllOf') {
        resultList.push('AND_ROLES_MATCH_ALL');
      } 
      else {
        resultList.push('AND_ROLES_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.roleCriteria, 'ROLE'));
    } else {
      resultList.push('<br>');
    }
  }
  else{
    if(jsonObj.roleCriteria !== undefined) {
      if(jsonObj.roleConjunction === 'AllOf'){
        resultList.push('ROLES_MATCH_ALL');
      } 
      else {
        resultList.push('ROLES_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.roleCriteria, 'ROLE'));
    }

    else {
      resultList.push('ALL_ROLES');
      resultList.push('<br>');
    }
  }
  return resultList;
}

var parseBRoleInfo = function(jsonObj) {
  var resultList = [];

  if(jsonObj.selectedBRoles !== undefined) {
    resultList.push('SELECT_BROLES');

    resultList.push(jsonObj.selectedBRoles.map(function (selectedBrole) {return selectedBrole.displayName;}).join(' | '));

    if(jsonObj.bRoleCriteria !== undefined) {

      if(jsonObj.BroleConjunction === 'AllOf') {
        resultList.push('AND_BROLES_MATCH_ALL');
      } 
      else {
        resultList.push('AND_BROLES_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.bRoleCriteria, 'BROLE'));
    } else {
      resultList.push('<br>');
    }
  }
  else{
    if(jsonObj.bRoleCriteria !== undefined) {
      if(jsonObj.bRoleConjunction === 'AllOf'){
        resultList.push('BROLES_MATCH_ALL');
      } 
      else {
        resultList.push('BROLES_MATCH_ANY');
      }

      resultList = resultList.concat(parseCriteria(jsonObj.bRoleCriteria, 'BROLE'));
    }

    else {
      resultList.push('ALL_BROLES');
      resultList.push('<br>');
    }
  }
  return resultList;
}

var parseCriteria = function (criteriaList, subtype) {
  var resultList = [];
  resultList.push('<br>');
  criteriaList.forEach (
    function(criteria){
      
      if(criteria.attributeKey !== undefined) {
        resultList.push('&nbsp;&nbsp;&nbsp;&nbsp;&#8226');
        resultList.push(getAttributeText(criteria.attributeKey, subtype, criteria.attributeEntity));
      }

      if(criteria.entities !== undefined) {
        if(criteria.kind !== undefined) {
          resultList.push('&nbsp;&nbsp;&nbsp;&nbsp;&#8226');
          resultList.push(getEntitiesKind(criteria.kind));
        }
        resultList.push(criteria.entities.map(function (entity) {return entity.displayName;}).join(' | '));
        resultList.push('<br>');
      } else if(criteria.kind !== undefined) {
        switch(criteria.kind) {
          case 'ncompare':
            resultList.push(getOperatorText(criteria.operator));
            resultList.push(criteria.nvalue.toString());
            resultList.push('<br>');
            break;
          case 'agocompare':
            resultList.push(getDaysAgoOperatorText(criteria.operator));
            resultList.push(criteria.daysAgo.toString());
            resultList.push('DAYS_AGO');
            resultList.push('<br>');
            break;
          case 'aheadcompare':
            resultList.push(getDaysAheadOperatorText(criteria.operator));
            resultList.push(criteria.daysAhead.toString());
            resultList.push('DAYS_FROM_NOW');
            resultList.push('<br>');
            break;
          case 'bcompare':
            resultList.push(criteria.bvalue.toString());
            resultList.push('<br>');
            break;
          case 'dcompare':
            var d = new Date(criteria.dvalue);
            resultList.push(getDateOperatorText(criteria.operator));
            resultList.push(d.toLocaleString());
            resultList.push('<br>');
            break;
        }
      } else if(criteria.values !== undefined) {
        resultList.push(criteria.values.join(' | '));
        resultList.push('<br>');
      }
    }
  )
  resultList.push('<br>');
  return resultList;
}

var localizeJSON = function(jsonStr, localizer) {
  var jsonObj = JSON.parse(jsonStr);
  var resultList = [];
  if(jsonObj !== null && localizer !== null && jsonObj.reviewSubtype !== undefined){
    var subtypes = jsonObj.reviewSubtype;

    subtypes.forEach(
      function(subtype) {
        switch(subtype){
          case 'PERMISSION':
            resultList = resultList.concat(parsePermissionInfo(jsonObj, localizer));
            break;

          case 'USER':
            resultList = resultList.concat(parseUserInfo(jsonObj, localizer));
            break;

          case 'ACCOUNT':
            resultList = resultList.concat(parseAccountInfo(jsonObj, localizer, 'ACCOUNT'));
            break;

          case 'MAPPED_ACCOUNT':
            resultList = resultList.concat(parseAccountInfo(jsonObj, localizer, 'MAPPED_ACCOUNT'));
            break;

          case 'ORPHAN':
            resultList = resultList.concat(parseOrphanInfo(jsonObj));
            break;

          case 'APPLICATION':
            resultList = resultList.concat(parseApplicationInfo(jsonObj));
            break;

          case 'ROLE':
            resultList = resultList.concat(parseRoleInfo(jsonObj));
            break;
          case 'BUSINESS_ROLE':
            resultList = resultList.concat(parseBRoleInfo(jsonObj));
        }
    })

    return resultList.map(function(str) {
       return localizer.getString(str);
    }).join(' ');
  } 
}

var extractGroupOption = function(jsonStr) {
    var jsonObj = JSON.parse(jsonStr);
     if(jsonObj !== null && jsonObj.groupInRoles !== undefined) {
         return jsonObj.groupInRoles;
     }
     
     return false;
}